<template>
    <el-dialog
        v-model="isDialogVisible"
        width="600px"
        :title="id !== null ? 'Редактирование теста' : 'Добавление теста'"
        class="edit-test"
        @close="$emit('close')"
    >
        <el-form label-position="top" v-model="formValues">
            <el-form-item>
                <el-radio-group v-model="formValues.type">
                    <el-radio-button label="name">Только name</el-radio-button>
                    <el-radio-button label="json"> Все исходные данные </el-radio-button>
                </el-radio-group>
            </el-form-item>
            <el-form-item prop="data" label="Значение name" v-if="formValues.type === 'name'">
                <el-input type="text" v-model="formValues.data.name" :class="{ 'has-error': !this.isValid.data }" />
            </el-form-item>
            <el-form-item prop="data" label="Исходные данные в JSON" v-else>
                <div>TODO: Не работает, нужно доделать</div>
                <el-input type="textarea" v-model="formValues.data" :class="{ 'has-error': !this.isValid.data }" />
            </el-form-item>
            <h4>Ожидаемый результат</h4>
            <div class="two-cols">
                <div v-for="param in expectedKeysTypes" :key="param.slug">
                    <label>{{ param.slug }}</label>
                    <el-select
                        v-if="param.type === 'bool'"
                        :model-value="expectedJson[param.slug]"
                        @update:modelValue="(newValue) => updateExpected(param.slug, newValue)"
                    >
                        <el-option label="(не задано)" value=""> (не задано) </el-option>
                        <el-option label="TRUE" :value="true">TRUE</el-option>
                        <el-option label="FALSE" :value="false"> FALSE </el-option>
                    </el-select>
                    <el-input
                        v-else
                        :model-value="expectedJson[param.slug]"
                        @update:modelValue="(newValue) => updateExpected(param.slug, newValue)"
                    />
                </div>
            </div>
        </el-form>
        <template #footer>
            <el-button type="primary" @click="maybeSave">
                {{ id ? "Сохранить тест" : "Добавить тест" }}
            </el-button>
        </template>
    </el-dialog>
</template>

<script>
export default {
    props: {
        isVisible: Boolean,
        id: [Number, String, null],
        params: Array,
        modelValue: Object,
    },
    emits: ["update:modelValue", "save", "close"],
    data() {
        return {
            expected: {},
        };
    },
    computed: {
        isDialogVisible: {
            get() {
                return this.isVisible;
            },
            set() {},
        },
        formValues: {
            get() {
                return this.modelValue;
            },
            set(value) {
                this.$emit("update:modelValue", value);
            },
        },
        expectedKeysTypes() {
            const result = [
                { slug: "vendor", type: "string" },
                { slug: "model", type: "string" },
            ];
            this.params
                .filter((item) => item.slug !== "vendor" && item.slug !== "model")
                .forEach((param) => result.push({ slug: param.slug, type: param.type }));
            return result;
        },
        expectedJson() {
            const expectedString = this.formValues.expected || "{}";
            let result;
            try {
                result = JSON.parse(expectedString);
                return result;
            } catch (e) {
                return {};
            }
        },
    },
    methods: {
        updateExpected(key, newValue) {
            const newExpected = { ...this.expectedJson };
            let type = "string";
            this.expectedKeysTypes.forEach((param) => {
                if (param.slug === key) type = param.type;
            });
            /* eslint-disable */
            switch (type) {
                case "int":
                    newExpected[key] = parseInt(newValue);
                    if (isNaN(newExpected[key])) newExpected[key] = null;
                    break;
                case "float":
                    newExpected[key] = parseFloat(newValue);
                    if (isNaN(newExpected[key])) newExpected[key] = null;
                    break;
                case "bool":
                    newExpected[key] = newValue === "" ? "" : !!newValue;
                    break;
                case "string":
                default:
                    newExpected[key] = newValue;
            }
            /* eslint-enable */
            // Пропускаем пустые значения
            for (let i in newExpected) {
                if (newExpected[i] === null || newExpected[i] === "") delete newExpected[i];
            }
            this.formValues.expected = { ...newExpected };
        },
        maybeSave() {
            if (!this.isValid.data || !this.isValid.expected) return;
            this.$emit("save", this.id, this.formValues);
        },
    },
};
</script>

<style lang="scss" scoped>
.has-error {
    --el-border-color: red;
    --el-fill-color-blank: #ffeeee;
}
.two-cols {
    display: flex;
    flex-wrap: wrap;
    & > div {
        width: calc(48% - 10px);
        margin-bottom: 20px;
        &:nth-child(2n + 1) {
            padding-right: 10px;
        }
        &:nth-child(2n) {
            padding-left: 10px;
        }
    }
}
.el-select {
    display: block;
}
</style>
